/*
 * @Descripttion: 
 * @version: 
 * @Author: Lone
 * @Date: 2021-10-22 20:46:03
 * @LastEditors: Lone
 * @LastEditTime: 2021-12-17 20:27:28
 */
import Vue from 'vue';
import Api from '@/services/api';
import { message } from 'ant-design-vue'

// console.log('stores mail 模块中引入的Api: ', Api);

  const state = {
    fromData: {
        from: '',//存储从哪里跳转到邮件详情页， inbox 、sent
        page: 1,//存储 从哪里跳转来的 页码，inbox 第几页
    },
    inboxList: [], //收件夾列表
    inboxCount: 0, //收件夾郵件總數量
    sentList: [],// 寄件備份列表
    sentCount: 0,//寄件備份數量
    currentSyncMailId: -1,//當前同步所同步郵箱的ID
    currentSyncMail: null,//當前所同步郵箱的全部信息
    isMailSyncing: true,//是否有郵件正在同步
    newMailCount: 0,
    folderList: [],//folderType: 1收件夹、2sent 寄件夹、3drafts 草稿箱
    // modelData: ['測試一','測試二','測試三','測試四','測試四','測試四','測試四','測試四','測試四'],
    modelData: [{
      id: 0,
      title: '测试一',
      type: 1,
      subject: '测试一的主题',
      content: '测试一的正文'
    },{
      id: 1,
      title: '测试二',
      type: 2,
      subject: '测试二的主题',
      content: '测试二的正文'
    }],
  };  
  
  const getters = {
   
  };
  
  const mutations = {
      SET_DETAIL_FROM (state, data) {
          state.fromData.from = data.from;
          state.fromData.page = data.page
      },
    SET_MAIL_STATUS (state, data) {//更改郵件狀態， 已讀、未讀
        state.inboxList.forEach(item => {
            if (item.id == data.id) {
                item.flags = data.flags;
            };
        });
    },
      SET_NEW_MAIL_COUNT (state, data) {
            state.newMailCount = data;
      },
    SET_FOLDER_LIST (state, data) {
      state.folderList = data;
    },
    //同步相關
    SET_CURRENT_SYNC_MAIL (state, data) {//存儲用戶所綁定的所有郵件數據
        state.currentSyncMail = data;
    },
    SET_CURRENT_SYNC_MAILID (state, data) {
        state.currentSyncMailId = data;
    },
    SET_IS_MAIL_ACTIVE (state, data) {//設置是否有郵件正在同步
        state.isMailSyncing = data;
    },
    //收件夾
    SET_INBOX_LIST (state, data) {//存儲收件夾數據，//todo: 後面改為SET_INBOX_LIST
      state.inboxList = data;
    },
    SET_INBOX_COUNT (state, data) {
        state.inboxCount = data;
    },
    //寄件夾
    SET_SENT_LIST (state, data) {//存儲寄件夾數據
        state.sentList = data;
    },
    SET_SENT_COUNT (state, data) {//存儲收件夾數量
        state.sentCount = data;
    },
    DEL_MODEL (state, id) {
      state.modelData = state.modelData.filter(item => { return item.id != id });
    },
    ADD_MODEL (state, data) {
      // console.log('到ADD_TAG', data);
      data.id = state.modelData.length;
      state.modelData.push(data)
    },
    EDIT_MODEL (state, [id,data]) {
      // console.log('修改范本',id, data);
      state.modelData.forEach((item, index) => {
        if (item.id == id) {
          //以下解决 这里更改后，对应组件computed不更新的问题
          Vue.set(state.modelData, index, data)
          console.log('修改后的范本1:', item);
        }
      })
      // Vue.$set()
    },
  };
  
const actions = {
    getFolderList ({commit}, params) {
        return new Promise((resolve,reject) => {
            Api.mail.getFolderList(params).then(res => {
                // console.log('getFolderList请求回来的数据为：', res);
                if (res.code != 0) {
                    resolve(false);
                    message.error('请求邮件文件夾列表失败');
                } else {
                    resolve(res.data.data);
                    // message.success('请求成功');
                    commit('SET_FOLDER_LIST', res.data.data);
                    // commit('SET_INBOX_COUNT', res.data.total);
                };
            });
        });
    },
    getMessageList ({commit}, [ params, type]) {//根據參數來 進行不同文件夾的請求。
        return new Promise((resolve,reject) => {
            Api.mail.getMessageList(params).then(res => {
                // console.log('getMessageList请求回来的数据为：', res);
                if (res.code != 0) {
                    resolve(false);
                    message.error('请求列表失败');
                } else {
                    resolve(res.data);
                    // message.success('请求成功');
                    if (type == 1) {
                        commit('SET_INBOX_LIST', res.data.data);
                        commit('SET_INBOX_COUNT', res.data.total);
                    } else if (type == 4) {
                        commit('SET_SENT_LIST', res.data.data);
                        commit('SET_SENT_COUNT', res.data.total);
                    };
                };
            })
        });
    },
    getMailAccountList ({commit}) {
        return new Promise((resolve,reject) => {
            Api.mail.getAccountList({
                "page": {
                    "current": 0,
                    "size": 10
                }
            }).then(res => {
                // console.log('獲取郵箱賬號的結果為： ',res);
                if (res.code != 0) resolve(false);
                res = res.data;
                if (res.total > 0) {
                    let mailActiveResult = res.data.some(item => item.mailStatus == 1);
                    commit('SET_IS_MAIL_ACTIVE', mailActiveResult);
                    if (mailActiveResult) {
                        let currentSyncMail = res.data.find(item => item.mailStatus == 1);
                        commit('SET_CURRENT_SYNC_MAILID', currentSyncMail.id);
                        commit('SET_CURRENT_SYNC_MAIL', currentSyncMail);
                    } else {
                        commit('SET_CURRENT_SYNC_MAIL', res.data[0]);
                    };
                };
                resolve(res);
            })
        })
        
    },
    //新增、修改Model
    editModel ({commit},[id,data]) {//
      return new Promise((resolve, reject) => {
          if (id < 0) {//新增
            // console.log('新增');
            commit('ADD_MODEL', data);
          } else {//修改
            // console.log('修改');
            commit('EDIT_MODEL',[id,data]);
          }
          resolve(true);
      })
    },
    //刪除范本
    delModel ({commit}, id) {
          return new Promise((resolve, reject) => {
              console.log(typeof id == 'number');
              if (typeof id == 'number') {
                commit('DEL_MODEL', id);
              } else {
                // let idArray = id.split(',');
                console.log(id);
                id.forEach(item => {
                   commit('DEL_MODEL', item);
                });
              };
              resolve(true);
          })
    },
  };
  
   
  export default {
    namespaced: true,
    state,
    getters,
    actions,
    mutations,
  }
  