/*
 * @Author: your name
 * @Date: 2021-09-28 21:56:38
 * @LastEditTime: 2022-01-02 23:28:42
 * @LastEditors: Lone
 * @Description: In User Settings Edit
 * @FilePath: \crm\src\stores\tags\index.js
 */
import Api from '@/services/api';
import { message } from 'ant-design-vue'

const state = {

    userData:[
      {
        key: 0,        
        username: "Administrator",
        password: "1234",
      },
      {
        key: 1,        
        username: "user1",
        password: "1234",
      },
      {
        key: 2,        
        username: "test1",
        password: "123456",
      }, 
      {
        key: 2,        
        username: "admin",
        password: "admin",
      },
    ],
    currentUser:{},
    token: localStorage.getItem('x-auth-token') || '',
    userInfo: JSON.parse(localStorage.getItem('userInfo')) || '',
};  
  
const getters = {
    getUserData: state => {
      let userData = state.userData
      userData = userData.filter(item => { return item.completed == false });
      return userData;
    },
    getApiData: state => {
      let apiData = state.apiData.push({
          id:"1",
          name:"資料"
      })
      console.log("store --- apiData----",apiData)
      return state.apiData;
    }
};
  
const mutations = {
    SET_USER_INFO: (state, data) => {
        state.userInfo = data;
    },
    SET_TOKEN: (state, token) => {
        state.token = token;
    },
    //取得userData 
    GET_CURRENT_USER (state, data) {
        console.log('到GET_CURRENT_USER', data);
        let userData = state.userData
        console.log("state.userData length",userData.length + 1)
        userData = userData.filter(item => { return item.username == data.username && item.password == data.password });
        console.log('userData', userData);
        state.currentUser = userData
        
        //設定登入使用者　localStorage
        localStorage.setItem('currentUser',JSON.stringify(userData));
        console.log('currentUser', state.currentUser);
    },
    //新增使用者
    ADD_USER_DATA (state, data) {
      console.log('到ADD_USER_DATA', data);
      let userData = state.userData
      console.log("state.userData length",userData.length + 1)
      data.key = userData.length
      state.userData.push(data)
    },
    //修改使用者
    EDIT_USER_DATA (state, data) {
      let userData = state.userData
      userData.forEach(item => {
        if (item.key == data.key) {
          item.password = data.confirm_password;
        }
      })
      console.log("EDIT_USER_DATA state",state.userData)
      console.log("EDIT_USER_DATA data",data)
      console.log("userData userData",userData)
    },
    //刪除使用者
    DEL_USER_DATA (state, key) {
      state.userData = state.userData.filter(item => { return item.key != key });
      //console.log("key--",key)
    },
};
  
const actions = {
    // 用户登录
    login({ commit }, userInfo) {
        const { username, password } = userInfo
        return new Promise((resolve, reject) => {
            Api.user.login({ 
                username: username.trim(), 
                password: password,
                grant_type: 'password',
                client_id: 'client-pc',
                client_secret: '123456'
            }).then(res => {
                const { data } = res;
                let token = `${data.tokenHead}${data.token}`;
                commit('SET_TOKEN', token);
                resolve()
            }).catch(error => {
                reject(error)
            })
        })
    },
    logout({ commit }) {
        // 退出登录时，清除token
        localStorage.removeItem('x-auth-token');
        commit('SET_TOKEN', '');

        // 退出登录时，清除userInfo
        localStorage.removeItem('userInfo');
        commit('SET_USER_INFO', '');
    },
    // 获取用户登录信息
    queryUserInfo({commit}) {
        return new Promise((resolve,reject) => {
            Api.user.queryLoginUserInfo().then(res => {
                if (res.code != 0 ) return message.error(res.message || '獲取用戶信息失败'),resolve(false);
                const { data } = res;
                commit('SET_USER_INFO', data);
                localStorage.setItem('userInfo', JSON.stringify(data));
                resolve(true)
            }).catch(error => {
                message.error('獲取用戶信息失败！');
                reject();
            })
        });     
    },
    //取得userData
    getCurrentUser ({commit},data) {
        console.log('user/getCurrentUser',data);
        return new Promise((resolve, reject) => {
            commit('GET_CURRENT_USER', data);
            resolve(true);
        })
    },
    //新增行程 
    addUserData ({commit},data) {
        console.log('activity/addUserData',data);
        return new Promise((resolve, reject) => {
            commit('ADD_USER_DATA', data);
            resolve(true);
        })
    },
    //修改行程
    async editUserData ({commit},data) {//key 為就的tagTitle，data為新的tagTitle
        console.log('到修改行程的UserData', data);
        return new Promise((resolve, reject) => {
            commit('EDIT_USER_DATA',data);
            resolve(true);
        })
    },
    //刪除行程
    async delUserData ({commit},obj) {
        //console.log("obj--key--",obj.key)
        return new Promise((resolve, reject) => {
            commit('DEL_USER_DATA', obj.key);
            resolve(true);
        })
    },
};
  
   
  export default {
    namespaced: true,
    state,
    getters,
    actions,
    mutations,
  }
  